# coding: utf-8

"""
    Jenga API

    API for Jenga payment processing and transaction management

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AuthenticationResponse(BaseModel):
    """
    AuthenticationResponse
    """ # noqa: E501
    access_token: Optional[StrictStr] = Field(default=None, description="JWT access token", alias="accessToken")
    expires_in: Optional[datetime] = Field(default=None, description="Token expiration timestamp", alias="expiresIn")
    issued_at: Optional[datetime] = Field(default=None, description="When the token was issued", alias="issuedAt")
    token_type: Optional[StrictStr] = Field(default=None, description="Type of token", alias="tokenType")
    refresh_token: Optional[StrictStr] = Field(default=None, description="Token used to refresh the access token", alias="refreshToken")
    __properties: ClassVar[List[str]] = ["accessToken", "expiresIn", "issuedAt", "tokenType", "refreshToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthenticationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthenticationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessToken": obj.get("accessToken"),
            "expiresIn": obj.get("expiresIn"),
            "issuedAt": obj.get("issuedAt"),
            "tokenType": obj.get("tokenType"),
            "refreshToken": obj.get("refreshToken")
        })
        return _obj


