# coding: utf-8

"""
    Jenga API

    API for Jenga payment processing and transaction management

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jenga_client.models.bill_payment_request_bill import BillPaymentRequestBill
from jenga_client.models.bill_payment_request_biller import BillPaymentRequestBiller
from jenga_client.models.bill_payment_request_payer import BillPaymentRequestPayer
from typing import Optional, Set
from typing_extensions import Self

class BillPaymentRequest(BaseModel):
    """
    BillPaymentRequest
    """ # noqa: E501
    biller: BillPaymentRequestBiller
    bill: BillPaymentRequestBill
    payer: BillPaymentRequestPayer
    partner_id: StrictStr = Field(description="The ID of the partner initiating the payment", alias="partnerId")
    remarks: Optional[StrictStr] = Field(default=None, description="Additional remarks about the payment")
    __properties: ClassVar[List[str]] = ["biller", "bill", "payer", "partnerId", "remarks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BillPaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of biller
        if self.biller:
            _dict['biller'] = self.biller.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bill
        if self.bill:
            _dict['bill'] = self.bill.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payer
        if self.payer:
            _dict['payer'] = self.payer.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BillPaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "biller": BillPaymentRequestBiller.from_dict(obj["biller"]) if obj.get("biller") is not None else None,
            "bill": BillPaymentRequestBill.from_dict(obj["bill"]) if obj.get("bill") is not None else None,
            "payer": BillPaymentRequestPayer.from_dict(obj["payer"]) if obj.get("payer") is not None else None,
            "partnerId": obj.get("partnerId"),
            "remarks": obj.get("remarks")
        })
        return _obj


