# coding: utf-8

"""
    Jenga API

    API for Jenga payment processing and transaction management

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class IMTWithinEquityRequestSender(BaseModel):
    """
    IMTWithinEquityRequestSender
    """ # noqa: E501
    name: StrictStr = Field(description="The name of the sender")
    document_type: StrictStr = Field(description="The type of document", alias="documentType")
    document_number: StrictStr = Field(description="The document number of the sender", alias="documentNumber")
    country_code: StrictStr = Field(description="The country code of the sender", alias="countryCode")
    mobile_number: StrictStr = Field(description="The mobile number of the sender", alias="mobileNumber")
    email: StrictStr = Field(description="The email address of the sender")
    address: Optional[StrictStr] = Field(default=None, description="The address of the sender")
    __properties: ClassVar[List[str]] = ["name", "documentType", "documentNumber", "countryCode", "mobileNumber", "email", "address"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IMTWithinEquityRequestSender from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IMTWithinEquityRequestSender from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "documentType": obj.get("documentType"),
            "documentNumber": obj.get("documentNumber"),
            "countryCode": obj.get("countryCode"),
            "mobileNumber": obj.get("mobileNumber"),
            "email": obj.get("email"),
            "address": obj.get("address")
        })
        return _obj


