# coding: utf-8

"""
    Jenga API

    API for Jenga payment processing and transaction management

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class MPesaCallbackResponseTransaction(BaseModel):
    """
    MPesaCallbackResponseTransaction
    """ # noqa: E501
    var_date: Optional[datetime] = Field(default=None, description="Transaction date", alias="date")
    reference: Optional[StrictStr] = Field(default=None, description="Transaction reference")
    payment_mode: Optional[StrictStr] = Field(default=None, description="Payment mode", alias="paymentMode")
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Transaction amount")
    currency: Optional[StrictStr] = Field(default=None, description="Transaction currency")
    service_charge: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Service charge", alias="serviceCharge")
    bill_number: Optional[StrictStr] = Field(default=None, description="Bill number", alias="billNumber")
    served_by: Optional[StrictStr] = Field(default=None, description="Service provider", alias="servedBy")
    additional_info: Optional[StrictStr] = Field(default=None, description="Additional information", alias="additionalInfo")
    order_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Order amount", alias="orderAmount")
    order_currency: Optional[StrictStr] = Field(default=None, description="Order currency", alias="orderCurrency")
    status: Optional[StrictStr] = Field(default=None, description="Transaction status")
    remarks: Optional[StrictStr] = Field(default=None, description="Transaction remarks")
    __properties: ClassVar[List[str]] = ["date", "reference", "paymentMode", "amount", "currency", "serviceCharge", "billNumber", "servedBy", "additionalInfo", "orderAmount", "orderCurrency", "status", "remarks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MPesaCallbackResponseTransaction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MPesaCallbackResponseTransaction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "date": obj.get("date"),
            "reference": obj.get("reference"),
            "paymentMode": obj.get("paymentMode"),
            "amount": obj.get("amount"),
            "currency": obj.get("currency"),
            "serviceCharge": obj.get("serviceCharge"),
            "billNumber": obj.get("billNumber"),
            "servedBy": obj.get("servedBy"),
            "additionalInfo": obj.get("additionalInfo"),
            "orderAmount": obj.get("orderAmount"),
            "orderCurrency": obj.get("orderCurrency"),
            "status": obj.get("status"),
            "remarks": obj.get("remarks")
        })
        return _obj


