# coding: utf-8

"""
    Jenga API

    API for Jenga payment processing and transaction management

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class MPesaStkPushRequestOrder(BaseModel):
    """
    MPesaStkPushRequestOrder
    """ # noqa: E501
    order_reference: StrictStr = Field(description="Order reference, should be unique per order", alias="orderReference")
    order_amount: Union[StrictFloat, StrictInt] = Field(description="Original order amount", alias="orderAmount")
    order_currency: StrictStr = Field(description="Currency of the order", alias="orderCurrency")
    source: StrictStr = Field(description="Source of the order")
    country_code: StrictStr = Field(description="Source country code (alpha-2)", alias="countryCode")
    description: StrictStr = Field(description="Description of the order")
    __properties: ClassVar[List[str]] = ["orderReference", "orderAmount", "orderCurrency", "source", "countryCode", "description"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MPesaStkPushRequestOrder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MPesaStkPushRequestOrder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "orderReference": obj.get("orderReference"),
            "orderAmount": obj.get("orderAmount"),
            "orderCurrency": obj.get("orderCurrency"),
            "source": obj.get("source"),
            "countryCode": obj.get("countryCode"),
            "description": obj.get("description")
        })
        return _obj


